Agent/TCP/TCP-DTN instproc init { args } {
	eval $self next $args
}

Agent/TCPSink/TCP-DTNSink instproc init { args } {
	eval $self next $args
}

Agent/DTN instproc init { args } {
	eval $self next $args

# Moved to C++/defaults	
#	$self instvar node_ tcp_packet_size_
#	set tcp_packet_size_ 1500
	
	set node_ ""
}

Node instproc attach-dtn { dtnagent } {
	$self instvar address_
 
 	$dtnagent set node_ $self
 	$dtnagent set agent_addr_ [AddrParams addr2id $address_]
}

Simulator instproc attach-dtnagent { node agent } {
	$node attach-dtn $agent
}

Simulator instproc connect-dtn { src dst } {
	$src add-downstream-agent $dst
	$dst add-upstream-agent $src
}

Simulator instproc connect-tcp { src dst } {
# Source DtnAgent
	set downstream_agent [new Agent/TCP/TCP-DTN]
	$downstream_agent set packetSize_ [$src set nTCPPacketSize_]
	$downstream_agent set class_ 1
	[$src set node_] attach $downstream_agent
	
	set downstream_sink [new Agent/TCPSink/TCP-DTNSink]
	$downstream_sink set class_ 2
	[$src set node_] attach $downstream_sink

# Destination DtnAgent
	set upstream_agent [new Agent/TCP/TCP-DTN]
	$upstream_agent set packetSize_ [$dst set nTCPPacketSize_]
	$upstream_agent set class_ 2
	[$dst set node_] attach $upstream_agent
	
	set upstream_sink [new Agent/TCPSink/TCP-DTNSink]
	$upstream_sink set class_ 1
	[$dst set node_] attach $upstream_sink

# Connect and attach
	$self connect $downstream_agent $upstream_sink
	$self connect $upstream_agent $downstream_sink
	
	$src attach-down-tcp $dst $downstream_agent $downstream_sink
	$dst attach-up-tcp $src $upstream_agent $upstream_sink
}
