#ifndef ns_tcpdtnsink_h
#define ns_tcpdtnsink_h

#include "tcp-sink.h"
#include "tcp-dtn.h"
#include "dtn.h"

class TcpDtnSink : public TcpSink {

public:
	TcpDtnSink(Acker* acker);
	void 				recv(Packet* pPacket, Handler* pHandler);
	void 				SetDTNAgent(DtnAgent *pDtnAgent) { m_pDtnAgent = pDtnAgent; }

protected:
	DtnAgent 			*m_pDtnAgent;
	BundleManagerTCP	bundleManagerTCP_;
};

#endif
